#include <math.h>
#include <stdio.h>
#include "Branin.h"

Branin::Branin ( void ) : objective_function ()
{
    int i;
    Dim = 2;
    Domain = new p_double [Dim];
    for ( i=0; i<Dim; i++ )
        Domain[i] = new double [3];
    Domain[0][0]=-5.0;
    Domain[0][1]=10.0;
    Domain[0][2]=0.0;
    Domain[1][0]=0.0;
    Domain[1][1]=15.0;
    Domain[1][2]=0.0;
    optimum = new double;
    *optimum = -0.39789;
    precision = -0.01*(*optimum);
    Return_to_domain=1;
    sprintf ( name, "Branin" );
    outfile = new char [256];
    sprintf ( outfile, "%s_001.out", name );
    int runi = 1;
    FILE *f;
    f = fopen(outfile, "rt");
    while (f) {
      fclose( f );
      runi++;
      sprintf( outfile, "%s_%03d.out", name, runi );
      f = fopen(outfile, "rt");
    }
}

double Branin::value ( double *oCH )
{
    double f;
    double a,b,c,d,h,e;

    a=1;
    b=5.1/(4*M_PI*M_PI);
    c=5/M_PI;
    d=6;
    h=10;
    e=1/(8*M_PI);

    f=a*pow(oCH[1]-b*oCH[0]*oCH[0]+c*oCH[0]-d, 2)+h*(1-e)*cos(oCH[0])+h;

    return -f;
}

/*
author: Anicka Kucerova, Czech Technical University in Prague
version 0.0.1
16 Mar 2009
*/
